# -*- coding: utf-8 -*-

# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

__author__ = "Ildar Nikolaev"
__email__ = "nildar@users.sourceforge.net"

url_manual_prefix = "http://support.nextlimit.com/display/mxdocsv3/"

url_manual_mapping = (
    ("bpy.types.MaxwellRenderProperties.cmdline", "Command+Line"),
    ("bpy.types.MaxwellRenderProperties.cmdline_no*", "Running+flags"),
    ("bpy.types.MaxwellRenderProperties.cmdline_trytoresume", "Parameters"),
    # Render Options
    ("bpy.types.MaxwellParamsProperties.quality", "Render+Options#RenderOptions-Quality"),
    ("bpy.types.MaxwellParamsProperties.threads", "Render+Options#RenderOptions-CPUThreads"),
    ("bpy.types.MaxwellParamsProperties.time", "Render+Options#RenderOptions-Time(min)"),
    ("bpy.types.MaxwellParamsProperties.sl", "Render+Options#RenderOptions-SamplingLevel"),
    ("bpy.types.MaxwellParamsProperties.multilight", "Render+Options#RenderOptions-Multilight"),
    # Globals
    ("bpy.types.MaxwellParamsProperties.motionblur", "Render+Options#RenderOptions-Globals"),
    ("bpy.types.MaxwellParamsProperties.mbsteps", "Render+Options#RenderOptions-Globals"),
    ("bpy.types.MaxwellParamsProperties.displacement", "Render+Options#RenderOptions-Globals"),
    ("bpy.types.MaxwellParamsProperties.dispersion", "Render+Options#RenderOptions-Globals"),
    # Materials
    ("bpy.types.MaxwellParamsProperties.ovrmat", "Render+Options#RenderOptions-Materials"),
    ("bpy.types.MaxwellParamsProperties.defmat", "Render+Options#RenderOptions-Materials"),
    ("bpy.types.MaxwellParamsProperties.active_sp_index", "Render+Options#RenderOptions-Materials"),
    # SimuLens
    ("bpy.types.MaxwellParamsProperties.doDiffraction", "Diffraction"),
    ("bpy.types.MaxwellParamsProperties.diffraction", "Diffraction"),
    ("bpy.types.MaxwellParamsProperties.frequency", "Diffraction"),
    ("bpy.types.MaxwellParamsProperties.aperture", "Diffraction"),
    ("bpy.types.MaxwellParamsProperties.obstacle", "Diffraction"),
    ("bpy.types.MaxwellParamsProperties.doScattering", "Lens+Scattering"),
    ("bpy.types.MaxwellParamsProperties.scattering", "Lens+Scattering"),
    ("bpy.types.MaxwellParamsProperties.doDevignetting", "Devignetting"),
    ("bpy.types.MaxwellParamsProperties.devignetting", "Devignetting"),
    # Channels
    ("bpy.types.MaxwellChannelProperties.*", "Channels"),
    ("bpy.types.MaxwellChannelsProperties.output", "Channels#Channels-Outputmode"),
    ("bpy.types.MaxwellChannelsProperties.render_enabled", "Render+channel"),
    ("bpy.types.MaxwellChannelsProperties.render_type", "Render+channel"),
    #("bpy.types.MaxwellChannelsProperties.alpha.*", "Alpha+channel"),
    ("bpy.types.MaxwellChannelsProperties.alpha_opaque", "Alpha+channel#Alphachannel-Opaqueoption"),
    #("bpy.types.MaxwellChannelsProperties.z_buffer.*", "Z-buffer+channel"),
    ("bpy.types.MaxwellChannelsProperties.z_range", "Z-buffer+channel"),
    #("bpy.types.MaxwellChannelsProperties.shadow.*", "Shadow+channel"),
    #("bpy.types.MaxwellChannelsProperties.material_id.*", "MatID+-+ObjectID+channel#MatID-ObjectIDchannel-MaterialID"),
    #("bpy.types.MaxwellChannelsProperties.object_id.*", "MatID+-+ObjectID+channel#MatID-ObjectIDchannel-ObjectID"),
    #("bpy.types.MaxwellChannelsProperties.motion.*", "Motion+vector+channel"),
    #("bpy.types.MaxwellChannelsProperties.roughness.*", "Roughness+channel"),
    #("bpy.types.MaxwellChannelsProperties.fresnel.*", "Fresnel+channel"),
    #("bpy.types.MaxwellChannelsProperties.normals.*", "Normals+channel"),
    ("bpy.types.MaxwellChannelsProperties.normals_space", "Normals+channel"),
    #("bpy.types.MaxwellChannelsProperties.position.*", "Normals+channel"),
    ("bpy.types.MaxwellChannelsProperties.position_space", "Position+channel"),
    #("bpy.types.MaxwellChannelsProperties.uv.*", "UV+channel"),
    # Environment
    ("bpy.types.MaxwellEnvironmentProperties.type", "Environment+Lighting"),
    ("bpy.types.MaxwellEnvironmentProperties.sky", "Environment+Lighting#EnvironmentLighting-Sky"),
    # Constant Dome
    ("bpy.types.MaxwellConstantSkyProperties.*", "Constant+Dome"),
    # Physical Sky
    ("bpy.types.MaxwellPhysicalSkyProperties.intensity", "Physical+Sky#PhysicalSky-Intensity"),
    ("bpy.types.MaxwellPhysicalSkyProperties.planetRefl", "Physical+Sky#PhysicalSky-PlanetReflectance"),
    ("bpy.types.MaxwellPhysicalSkyProperties.ozone", "Physical+Sky#PhysicalSky-Ozone"),
    ("bpy.types.MaxwellPhysicalSkyProperties.water", "Physical+Sky#PhysicalSky-Water"),
    ("bpy.types.MaxwellPhysicalSkyProperties.angstrom", "Physical+Sky#PhysicalSky-TurbidityCoefficient"),
    ("bpy.types.MaxwellPhysicalSkyProperties.wavelength", "Physical+Sky#PhysicalSky-WavelengthExponent"),
    ("bpy.types.MaxwellPhysicalSkyProperties.albedo", "Physical+Sky#PhysicalSky-Reflectance"),
    ("bpy.types.MaxwellPhysicalSkyProperties.asymmetry", "Physical+Sky#PhysicalSky-Asymmetry"),
    # Sun
    ("bpy.types.MaxwellSunProperties.type", "Physical+Sky#PhysicalSky-Type"),
    ("bpy.types.MaxwellSunProperties.power", "Physical+Sky#PhysicalSky-SunPower"),
    ("bpy.types.MaxwellSunProperties.radius", "Physical+Sky#PhysicalSky-RadiusFactor"),
    ("bpy.types.MaxwellSunProperties.temperature", "Physical+Sky#PhysicalSky-SunTemperature(onlyavailableinPhysicalSkymode)"),
    ("bpy.types.MaxwellSunProperties.position", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.latitude", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.longitude", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.ui_date", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.ui_time", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.sm", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.rotation", "Physical+Sky#PhysicalSky-LocationandTime(LatitudeandLongitudemode)"),
    ("bpy.types.MaxwellSunProperties.zenith", "Physical+Sky#PhysicalSky-LocationandTime(Anglesmode)"),
    ("bpy.types.MaxwellSunProperties.azimuth", "Physical+Sky#PhysicalSky-LocationandTime(Anglesmode)"),
    ("bpy.types.MaxwellSunProperties.direction", "Physical+Sky#PhysicalSky-LocationandTime(Direction)"),
    # Image Based Lighting
    ("bpy.types.MaxwellIblProperties.*", "Image+Based+Lighting#ImageBasedLighting-GlobalIBLSettings"),
    ("bpy.types.MaxwellELBackgroundProperties.*", "Image+Based+Lighting#ImageBasedLighting-Background"),
    ("bpy.types.MaxwellELProperties.*", "Image+Based+Lighting#ImageBasedLighting-Channels"),
    # Objects
    ("bpy.types.MaxwellObjectProperties.opacity", "Special+object+properties#Specialobjectproperties-Opacity"),
    ("bpy.types.MaxwellObjectProperties.hide_to_camera", "Special+object+properties#Specialobjectproperties-HiddenfromCamera"),
    ("bpy.types.MaxwellObjectProperties.hide_to_rr", "Special+object+properties#Specialobjectproperties-HiddenfromReflections/Refractions"),
    ("bpy.types.MaxwellObjectProperties.hide_to_gi", "Special+object+properties#Specialobjectproperties-HiddenfromGlobalIllumination"),
    ("bpy.types.MaxwellObjectProperties.ecp", "Special+object+properties#Specialobjectproperties-HiddentoZ-clipPlanes"),
    ("bpy.types.MaxwellObjectProperties.backface_material", "Back-face+materials"),
    ("bpy.types.MaxwellObjectProperties.*", "Special+object+properties"),
    # Camera
    ("bpy.types.MaxwellCameraProperties.shtype", "Camera+parameters#Cameraparameters-Optics"),
    ("bpy.types.MaxwellCameraProperties.shutter", "Camera+parameters#Cameraparameters-Optics"),
    ("bpy.types.MaxwellCameraProperties.iso", "Camera+parameters#Cameraparameters-Sensor"),
    ("bpy.types.MaxwellCameraProperties.fstop", "Camera+parameters#Cameraparameters-Optics"),
    ("bpy.types.MaxwellCameraProperties.diaphragm", "Camera+parameters#Cameraparameters-Diaphragm"),
    ("bpy.types.MaxwellCameraProperties.blades", "Camera+parameters#Cameraparameters-Diaphragm"),
    ("bpy.types.MaxwellCameraProperties.angle", "Camera+parameters#Cameraparameters-Diaphragm"),
    ("bpy.types.MaxwellCameraProperties.*", "Camera+parameters"),
    # Material
    ("bpy.types.MaxwellMaterialProperties.type", "Global+Material+Properties#GlobalMaterialProperties-Type"),
    ("bpy.types.MaxwellMaterialProperties.bump*", "Global+Material+Properties#GlobalMaterialProperties-GlobalBump/Normalmap"),
    ("bpy.types.MaxwellMaterialProperties.dispersion", "Global+Material+Properties#GlobalMaterialProperties-Dispersion"),
    ("bpy.types.MaxwellMaterialProperties.shadow", "Global+Material+Properties#GlobalMaterialProperties-Shadow"),
    ("bpy.types.MaxwellMaterialProperties.matte", "Global+Material+Properties#GlobalMaterialProperties-Matte"),
    ("bpy.types.MaxwellMaterialProperties.color_id", "Global+Material+Properties#GlobalMaterialProperties-MaterialId"),
    # Material - Referenced
    ("bpy.types.MaxwellMaterialProperties.mxm", "Referenced+Materials"),
    ("bpy.ops.maxwell.material_browse_mxm", "Referenced+Materials"),
    # Material - Displacement
    ("bpy.types.MaxwellDisplacementProperties.type", "Displacement+component#Displacementcomponent-DisplacementTypes-Onthefly,PretesselatedandVector"),
    ("bpy.types.MaxwellDisplacementProperties.map", "Displacement+component#Displacementcomponent-Map"),
    ("bpy.types.MaxwellDisplacementProperties.level", "Displacement+component#Displacementcomponent-Subdivision"),
    ("bpy.types.MaxwellDisplacementProperties.adaptive", "Displacement+component#Displacementcomponent-Adaptive"),
    ("bpy.types.MaxwellDisplacementProperties.method", "Displacement+component#Displacementcomponent-SubdivisionMethod"),
    ("bpy.types.MaxwellDisplacementProperties.offset", "Displacement+component#Displacementcomponent-Offset"),
    ("bpy.types.MaxwellDisplacementProperties.smooth", "Displacement+component#Displacementcomponent-Smoothing"),
    ("bpy.types.MaxwellDisplacementProperties.uvi", "Displacement+component#Displacementcomponent-UVInterpolation"),
    ("bpy.types.MaxwellDisplacementProperties.height", "Displacement+component#Displacementcomponent-Height"),
    ("bpy.types.MaxwellDisplacementProperties.absolute", "Displacement+component#Displacementcomponent-HeightMapProperties(for1Ddisplacementonly)"),
    ("bpy.types.MaxwellDisplacementProperties.preset", "Displacement+component#Displacementcomponent-Preset"),
    ("bpy.types.MaxwellDisplacementProperties.transform", "Displacement+component#Displacementcomponent-Transform"),
    ("bpy.types.MaxwellDisplacementProperties.mapping", "Displacement+component#Displacementcomponent-RGBMapping"),
    ("bpy.types.MaxwellDisplacementProperties.scale", "Displacement+component#Displacementcomponent-Scale"),
    ("bpy.types.MaxwellDisplacementProperties.*", "Displacement+component"),
    # Material - Layer
    ("bpy.types.MaxwellMaterialProperties.active_layer_index", "Stacking+Layers"),
    ("bpy.types.MaxwellLayerProperties.opacity", "Stacking+Layers#StackingLayers-LayerOpacity"),
    ("bpy.types.MaxwellLayerProperties.opacity_tex", "Stacking+Layers#StackingLayers-LayerMask"),
    ("bpy.types.MaxwellLayerProperties.blend", "Stacking+Layers#StackingLayers-BlendingModes:NormalandAdditive"),
    ("bpy.types.MaxwellLayerProperties.*", "Stacking+Layers"),
    # Material - Emitter
    ("bpy.types.MaxwellEmitterProperties.type", "Lighting+with+Emitters#LightingwithEmitters-Emittertypes"),
    ("bpy.types.MaxwellEmitterProperties.color", "Custom+emitters#Customemitters-Color"),
    ("bpy.types.MaxwellEmitterProperties.luminance", "Custom+emitters#Customemitters-Luminance"),
    ("bpy.types.MaxwellEmitterProperties.power", "Custom+emitters#Customemitters-PowerandEfficacy"),
    ("bpy.types.MaxwellEmitterProperties.efficacy", "Custom+emitters#Customemitters-PowerandEfficacy"),
    ("bpy.types.MaxwellEmitterProperties.output*", "Custom+emitters#Customemitters-Luminouspower"),
    ("bpy.types.MaxwellEmitterProperties.ies", "IES+emitters"),
    ("bpy.types.MaxwellEmitterProperties.intensity", "IES+emitters"),
    ("bpy.types.MaxwellEmitterProperties.image", "Image+projection"),
    ("bpy.types.MaxwellEmitterProperties.temperature", "Lighting+with+Emitters#LightingwithEmitters-Temperature"),
    #("bpy.types.MaxwellEmitterProperties.hdri_tex", "Lighting+with+Emitters#LightingwithEmitters-HDRImage"),
    #("bpy.types.MaxwellEmitterProperties.hdri_intensity", "Lighting+with+Emitters#LightingwithEmitters-HDRImage"),
    ("bpy.types.MaxwellEmitterProperties.*", "Lighting+with+Emitters"),
    # Material - BSDF
    ("bpy.types.MaxwellBSDFProperties.weight", "Blending+BSDFs#BlendingBSDFs-Weights"),
    ("bpy.types.MaxwellBSDFProperties.weight_tex", "Blending+BSDFs#BlendingBSDFs-Weightmaps"),
    ("bpy.types.MaxwellBSDFProperties.refl_*", "Reflectance#Reflectance-Reflectance0ºandReflectance90º"),
    ("bpy.types.MaxwellBSDFProperties.trans*", "Transmissive+Properties#TransmissiveProperties-Transmittance"),
    ("bpy.types.MaxwellBSDFProperties.atten*", "Transmissive+Properties#TransmissiveProperties-Attenuation"),
    ("bpy.types.MaxwellBSDFProperties.nd", "Transmissive+Properties#TransmissiveProperties-ND"),
    ("bpy.types.MaxwellBSDFProperties.force_fresnel", "Transmissive+Properties#TransmissiveProperties-ForceFresnel"),
    ("bpy.types.MaxwellBSDFProperties.abbe", "Transmissive+Properties#TransmissiveProperties-Abbe(dispersion)"),
    ("bpy.types.MaxwellBSDFProperties.k", "Index+of+Refraction+-+ND+and+K#IndexofRefraction-NDandK-Kparameter"),
    ("bpy.types.MaxwellBSDFProperties.cf_*", "Custom+Fresnel+curve+-+r2"),
    ("bpy.types.MaxwellBSDFProperties.ior_file", "IOR+files"),
    ("bpy.types.MaxwellBSDFProperties.roughness*", "Surface+Properties#SurfaceProperties-Roughness"),
    ("bpy.types.MaxwellBSDFProperties.bump_normal", "Surface+Properties#SurfaceProperties-NormalMapping"),
    ("bpy.types.MaxwellBSDFProperties.bump*", "Surface+Properties#SurfaceProperties-BumpMapping"),
    ("bpy.types.MaxwellBSDFProperties.anisotropy*", "Surface+Properties#SurfaceProperties-Anisotropy"),
    ("bpy.types.MaxwellBSDFProperties.angle*", "Surface+Properties#SurfaceProperties-Angle"),
    ("bpy.types.MaxwellBSDFProperties.scattering*", "SubSurface+Properties#SubSurfaceProperties-Scattering"),
    ("bpy.types.MaxwellBSDFProperties.coef", "SubSurface+Properties#SubSurfaceProperties-Coef"),
    ("bpy.types.MaxwellBSDFProperties.asymmetry", "SubSurface+Properties#SubSurfaceProperties-Asymmetry"),
    ("bpy.types.MaxwellBSDFProperties.single_sided", "ThinSSS#ThinSSS-SingleSided"),
    ("bpy.types.MaxwellBSDFProperties.thickness", "ThinSSS#ThinSSS-SingleSided"),
    ("bpy.types.MaxwellBSDFProperties.thickness_tex", "ThinSSS#ThinSSS-SingleSided"),
    ("bpy.types.MaxwellBSDFProperties.thickness_*", "ThinSSS#ThinSSS-Min/Max"),
    ("bpy.types.MaxwellBSDFProperties.*", "The+BSDF"),
    # Material - Coating
    ("bpy.types.MaxwellCoatingProperties.*", "Coating+component"),
    # Texture
    ("bpy.types.MaxwellImageProjectionProperties.channel", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.tile_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.tile_y", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.units", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.repeat", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.mirror_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.mirror_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.offset", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProjectionProperties.rotation", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.override", "Global+Material+Properties#GlobalMaterialProperties-Overridemap"),
    ("bpy.types.MaxwellImageProperties.channel", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.tile_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.tile_y", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.units", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.repeat", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.mirror_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.mirror_x", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.offset", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.rotation", "Texture+Picker#TexturePicker-ProjectionProperties"),
    ("bpy.types.MaxwellImageProperties.invert", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.alpha_only", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.interpolation", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.brightness", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.contrast", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.saturation", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.hue", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.clamp", "Texture+Picker#TexturePicker-ImageProperties"),
    ("bpy.types.MaxwellImageProperties.flip_x", "Surface+Properties#SurfaceProperties-NormalMapping"),
    ("bpy.types.MaxwellImageProperties.flip_y", "Surface+Properties#SurfaceProperties-NormalMapping"),
    ("bpy.types.MaxwellImageProperties.wide", "Surface+Properties#SurfaceProperties-NormalMapping"),
    ("bpy.types.MaxwellImageProperties.*", "Texture+Picker"),
    # Bake textures
    #("bpy.ops.maxwell.bake_textures", "https://www.youtube.com/watch?v=pl4dNDUe69g"),
    #("bpy.types.MaxwellImageProperties.bake_*", "https://www.youtube.com/watch?v=pl4dNDUe69g"),
    #("bpy.types.MaxwellImageProperties.active_bt_index", "https://www.youtube.com/watch?v=pl4dNDUe69g"),
    # Maxwell Extensions
    ("bpy.types.MaxwellParticlesProperties.h_type", "Extensions#Extensions-ObjectModifierExtensions"),
    ("bpy.types.MaxwellParticlesProperties.p_type", "Extensions#Extensions-ExtensionObjects"),
    # Maxwell Sea
    ("bpy.types.MaxwellSeaProperties.enabled", "Maxwell+Sea"),
    ("bpy.types.MaxwellSeaProperties.quality", "Maxwell+Sea#MaxwellSea-Quality"),
    ("bpy.types.MaxwellSeaProperties.time", "Maxwell+Sea#MaxwellSea-ReferenceTime"),
    ("bpy.types.MaxwellSeaProperties.vertical_scale", "Maxwell+Sea#MaxwellSea-VerticalScale"),
    ("bpy.types.MaxwellSeaProperties.dimension", "Maxwell+Sea#MaxwellSea-Dimension"),
    ("bpy.types.MaxwellSeaProperties.depth", "Maxwell+Sea#MaxwellSea-Depth"),
    ("bpy.types.MaxwellSeaProperties.seed", "Maxwell+Sea#MaxwellSea-Seed"),
    ("bpy.types.MaxwellSeaProperties.choppyness", "Maxwell+Sea#MaxwellSea-ChoppynessandChoppyFactor"),
    ("bpy.types.MaxwellSeaProperties.choppy_factor", "Maxwell+Sea#MaxwellSea-ChoppynessandChoppyFactor"),
    ("bpy.types.MaxwellSeaProperties.wind_speed", "Maxwell+Sea#MaxwellSea-Wind"),
    ("bpy.types.MaxwellSeaProperties.wind_direction", "Maxwell+Sea#MaxwellSea-Wind"),
    ("bpy.types.MaxwellSeaProperties.weight_against_wind", "Maxwell+Sea#MaxwellSea-Wind"),
    ("bpy.types.MaxwellSeaProperties.wind_alignment", "Maxwell+Sea#MaxwellSea-Wind"),
    ("bpy.types.MaxwellSeaProperties.min_wave_length", "Maxwell+Sea#MaxwellSea-Wind"),
    # Maxwell Volumetric
    ("bpy.types.MaxwellVolumetricExtProperties.radius_factor", "Volumetrics#Volumetrics-Radiusmultiplier"),
    ("bpy.types.MaxwellVolumetricExtProperties.density_scale", "Volumetrics#Volumetrics-Densitymultiplier"),
    ("bpy.types.MaxwellVolumetricExtProperties.min_density", "Volumetrics#Volumetrics-Minfinaldensity"),
    ("bpy.types.MaxwellVolumetricExtProperties.max_density", "Volumetrics#Volumetrics-Maxfinaldensity"),
    ("bpy.types.MaxwellVolumetricExtProperties.cell_size", "Volumetrics#Volumetrics-Cellsize"),
    ("bpy.types.MaxwellVolumetricExtProperties.extra_particles", "Volumetrics#Volumetrics-Extraparticles"),
    ("bpy.types.MaxwellVolumetricExtProperties.extra_dispersion", "Volumetrics#Volumetrics-Extraparticlesdispersion"),
    ("bpy.types.MaxwellVolumetricExtProperties.extra_deformation", "Volumetrics#Volumetrics-Extraparticlesdeformation"),
    ("bpy.types.MaxwellVolumetricExtProperties.mb_factor", "Volumetrics#Volumetrics-Motionblurfactor"),
    ("bpy.types.MaxwellVolumetricExtProperties.*", "Volumetrics#Volumetrics-Particlebased"),
    # Maxwell Particles
    ("bpy.types.MaxwellParticlesExtProperties.*", "Maxwell+Particles"),
    # Maxwell Mesher
    ("bpy.types.MaxwellMesherExtProperties.radius", "Maxwell+Mesher#MaxwellMesher-Radius"),
    ("bpy.types.MaxwellMesherExtProperties.core", "Maxwell+Mesher#MaxwellMesher-Corefilter"),
    ("bpy.types.MaxwellMesherExtProperties.splash", "Maxwell+Mesher#MaxwellMesher-Splashfilter"),
    ("bpy.types.MaxwellMesherExtProperties.velocity", "Maxwell+Mesher#MaxwellMesher-Max.Velocity"),
    ("bpy.types.MaxwellMesherExtProperties.poly", "Maxwell+Mesher#MaxwellMesher-PolygonSize"),
    ("bpy.types.MaxwellMesherExtProperties.smooth", "Maxwell+Mesher#MaxwellMesher-Smooth"),
    ("bpy.types.MaxwellMesherExtProperties.filter", "Maxwell+Mesher#MaxwellMesher-FilterMesh"),
    ("bpy.types.MaxwellMesherExtProperties.relax", "Maxwell+Mesher#MaxwellMesher-Relax"),
    ("bpy.types.MaxwellMesherExtProperties.tension", "Maxwell+Mesher#MaxwellMesher-Tension"),
    #("bpy.types.MaxwellMesherExtProperties.thinning", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    ("bpy.types.MaxwellMesherExtProperties.steps", "Maxwell+Mesher#MaxwellMesher-Steps"),
    #("bpy.types.MaxwellMesherExtProperties.splash_thinning", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    #("bpy.types.MaxwellMesherExtProperties.splash_threshold", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    #("bpy.types.MaxwellMesherExtProperties.thinning_size", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    #("bpy.types.MaxwellMesherExtProperties.core_smooth", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    #("bpy.types.MaxwellMesherExtProperties.core_threshold", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    #("bpy.types.MaxwellMesherExtProperties.smooth_steps", "Maxwell+Mesher#MaxwellMesher-TheFilterssection"),
    ("bpy.types.MaxwellMesherExtProperties.optimize", "Maxwell+Mesher#MaxwellMesher-Optimize"),
    ("bpy.types.MaxwellMesherExtProperties.distance", "Maxwell+Mesher#MaxwellMesher-Distance"),
    ("bpy.types.MaxwellMesherExtProperties.threads", "Maxwell+Mesher#MaxwellMesher-Threads"),
    ("bpy.types.MaxwellMesherExtProperties.action", "Maxwell+Mesher#MaxwellMesher-Action"),
    ("bpy.types.MaxwellMesherExtProperties.md_file", "Maxwell+Mesher#MaxwellMesher-MDFile"),
    ("bpy.types.MaxwellMesherExtProperties.md_offset", "Maxwell+Mesher#MaxwellMesher-MDFrame#Offset"),
    ("bpy.types.MaxwellMesherExtProperties.md_compression", "Maxwell+Mesher#MaxwellMesher-The\"ExportandLazyCompute\"section"),
    ("bpy.types.MaxwellMesherExtProperties.md_normals", "Maxwell+Mesher#MaxwellMesher-The\"ExportandLazyCompute\"section"),
    ("bpy.types.MaxwellMesherExtProperties.*", "Maxwell+Mesher"),
    # Maxwell Hair and Fur
    ("bpy.types.MaxwellHairExtProperties.uv_map", "Hair+and+Fur#HairandFur-MappingtheFur/Hair"),
    ("bpy.types.MaxwellHairExtProperties.*", "Hair+and+Fur"),
    # Maxwell Grass
    ("bpy.types.MaxwellGrassExtProperties.type", "Grass#Grass-TheGrassPrimitives"),
    ("bpy.types.MaxwellGrassExtProperties.blade_points", "Grass#Grass-Primitive"),
    ("bpy.types.MaxwellGrassExtProperties.density", "Grass#Grass-Densityparameters"),
    ("bpy.types.MaxwellGrassExtProperties.density_map", "Grass#Grass-Densityparameters"),
    ("bpy.types.MaxwellGrassExtProperties.seed", "Grass#Grass-Densityparameters"),
    ("bpy.types.MaxwellGrassExtProperties.length", "Grass#Grass-Lengthparameters"),
    ("bpy.types.MaxwellGrassExtProperties.length_map", "Grass#Grass-Lengthparameters"),
    ("bpy.types.MaxwellGrassExtProperties.length_var", "Grass#Grass-Lengthparameters"),
    ("bpy.types.MaxwellGrassExtProperties.root_width", "Grass#Grass-Widthparameters"),
    ("bpy.types.MaxwellGrassExtProperties.tip_width", "Grass#Grass-Widthparameters"),
    ("bpy.types.MaxwellGrassExtProperties.angle", "Grass#Grass-Angleparameters"),
    ("bpy.types.MaxwellGrassExtProperties.angle_map", "Grass#Grass-Angleparameters"),
    ("bpy.types.MaxwellGrassExtProperties.angle_var", "Grass#Grass-Angleparameters"),
    ("bpy.types.MaxwellGrassExtProperties.*bend*", "Grass#Grass-Bendparameters"),
    ("bpy.types.MaxwellGrassExtProperties.cut_off*", "Grass#Grass-CutOffparameters"),
    ("bpy.types.MaxwellGrassExtProperties.lod_*", "Grass#Grass-LevelofDetailparameters"),
    ("bpy.types.MaxwellGrassExtProperties.display_*", "Grass#Grass-Displayparameters"),
    ("bpy.types.MaxwellGrassExtProperties.*", "Grass"),
)

special_map = (
    ((
        "bpy.ops.maxwell.bake_add_texture",
        "bpy.ops.maxwell.bake_remove_texture",
        "bpy.ops.maxwell.bake_textures",
        "bpy.types.MaxwellImageProperties.active_bt_index",
        "bpy.types.MaxwellImageProperties.bake_color",
        "bpy.types.MaxwellImageProperties.bake_save",
        "bpy.types.MaxwellImageProperties.bake_clear",
        "bpy.types.MaxwellBakeTextureProperties.enabled",
        "bpy.types.MaxwellBakeTextureProperties.name",
    ), "http://www.youtube.com/", "watch?v=pl4dNDUe69g"),
    ((
        "bpy.types.MaxwellEmitterProperties.hdri_tex",
        "bpy.types.MaxwellEmitterProperties.hdri_intensity",
    ), "http://support.nextlimit.com/", "x/0oEAAQ")  # http://support.nextlimit.com/pages/viewpage.action?pageId=16810450
)
