# -*- coding: utf-8 -*-

# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

__author__ = "Ildar Nikolaev"
__email__ = "nildar@users.sourceforge.net"

from bpy.types import Panel
from bl_ui.properties_data_camera import CameraButtonsPanel

from ..engine import MaxwellRenderEngine


class MaxwellCameraPanel(CameraButtonsPanel, Panel):
    COMPAT_ENGINES = {MaxwellRenderEngine.bl_idname}
    bl_label = "Maxwell Camera"

    def draw(self, context):
        layout = self.layout
        mx = context.camera.maxwell

        row = layout.row(align=True)
        row.prop(mx, "shtype", text="")
        if mx.shtype == 'SPEED':
            row.prop(mx, "shutter", text="")
        elif mx.shtype == 'ANGLE':
            row.prop(mx, "rotary", text="")
        row = layout.row(align=True)
        row.prop(mx, "iso")
        row.prop(mx, "fstop")

        layout.row().prop(mx, "diaphragm")
        row = layout.row(align=True)
        row.prop(mx, "blades")
        row.prop(mx, "angle")
        if mx.diaphragm == 'CIRCULAR':
            row.enabled = False
        row = layout.row()
        row.prop(mx, "correction")
